#include <reg552.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <intrins.h>
#include <math.h>
#include <dsw.h>

void I2C_Write(unsigned char Data,unsigned char ACK);
bit  I2C_Ack(unsigned char ACK);
void I2C_Start(void);
void I2C_Stop(void);
void Delay(void);
unsigned char I2C_Read(unsigned char d);

#define Dlzka 6

void Delay(void)
{
 unsigned char i=Dlzka;
 while(--i!=0x00);
}

void I2C_Start(void)
{
 Delay();
 SDA=0x01;
 SCL=0x01;
 Delay();
 SDA=0x00;
 Delay();
 SCL=0x00;
 Delay();
}

void I2C_Stop(void)
{
 Delay();
 SCL=0x01;
 Delay();
 SDA=0x01;
 Delay();
}

void I2C_Write(unsigned char Data,unsigned char ACK)
{
 unsigned char i;
 SCL=0x00;
 Delay();
 for(i=0x00; i<0x08; i++)
  {
   SDA=((Data&0x80)?1:0);
   Data<<=1;  
   Delay();
   SCL=0x01;
   Delay();
   SCL=0x00;
   Delay();
  }
 SCL=0x00;
 SDA=ACK;
 Delay();
}

unsigned char I2C_Read(unsigned char d)
{
 unsigned char i,Data;
 Delay();
 SCL=0x00;
 for(i=0x00; i<0x08; i++)
  {
   Delay();
   Data<<=1;
   SCL=0x01;
   Delay();
   Data|=SDA;	
   Delay();
   SCL=0x00;
   Delay();
  }
 SDA=d;
 Delay();
 return Data;
}

bit I2C_Ack(unsigned char ACK)
{
 bit i;
 SCL=0x01;
 Delay();
 i=SDA;
 Delay();
 SCL=0x00;
 Delay();
 SDA=ACK;
 return i;
}



    


