#include <reg552.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <intrins.h>
#include <dsw.h>
#include <rtx51.h>
#include <math.h>

extern void I2C_Write(unsigned char Data,unsigned char ACK);
extern void I2C_Start(void);
extern void I2C_Stop(void);
extern bit  I2C_Ack(unsigned char ACK);
extern unsigned char I2C_Read(unsigned char d);

#define ID_DS1631           0x90      //Idendifikacne cislo - adresa DS1631
#define START_CONVERT       0x51
#define STOP_CONVERT        0x22
#define READ_TEMPERATURE    0xAA

float Prevod(int Num)
{
 float VAL=0.0;
 VAL=(float)high(Num);
 if(low(Num)&0x80) VAL+=0.50000000;
 if(low(Num)&0x40) VAL+=0.25000000;
 if(low(Num)&0x20) VAL+=0.12500000;
 if(low(Num)&0x10) VAL+=0.06250000;
 if(low(Num)&0x08) VAL+=0.03125000;
 if(low(Num)&0x04) VAL+=0.01562500;
 if(low(Num)&0x02) VAL+=0.00781250;
 if(low(Num)&0x01) VAL+=0.00390625;
 return VAL;
}

int Teplota(void)
{
 int x;
 bit i;
//**************************************************
// Watchdog;
 I2C_Start();
 I2C_Write(ID_DS1631,1);
 i=I2C_Ack(1);
 I2C_Write(START_CONVERT,1);
 i=I2C_Ack(1);
 I2C_Stop();
//************************************************** 
// os_wait(K_TMO,1,NULL);
//**************************************************
// Watchdog;
 I2C_Start();
 I2C_Write(ID_DS1631,1);
 i=I2C_Ack(1);
 I2C_Write(STOP_CONVERT,0);
 i=I2C_Ack(0);
 I2C_Stop();
//**************************************************
// os_wait(K_TMO,1,NULL);
//**************************************************
// Watchdog;
 I2C_Start();
 I2C_Write(ID_DS1631,1);
 i=I2C_Ack(1);
 I2C_Write(READ_TEMPERATURE,1);
 i=I2C_Ack(1);
//**************************************************
// Watchdog;
 I2C_Start();
 I2C_Write(ID_DS1631+1,0);
 i=I2C_Ack(1);
 x=I2C_Read(0)*256;
 i=I2C_Ack(1);
//**************************************************
// os_wait(K_TMO,1,NULL);
//**************************************************
// Watchdog;
 x+=I2C_Read(1);
 i=I2C_Ack(1);
 I2C_Stop();
//**************************************************
 return(x);
}
